# coding: utf-8

"""
    Identity Service API

    A list of identity, account and service management APIs.  # noqa: E501

    OpenAPI spec version: 1.6.5
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class RoleResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'ref_link': 'str',
        'name': 'str',
        'display_name': 'str',
        'organization_link': 'str',
        'visible': 'bool',
        'org_id': 'str',
        'expires_at': 'int',
        'resource': 'str',
        'id': 'str'
    }

    attribute_map = {
        'ref_link': 'refLink',
        'name': 'name',
        'display_name': 'displayName',
        'organization_link': 'organizationLink',
        'visible': 'visible',
        'org_id': 'orgId',
        'expires_at': 'expiresAt',
        'resource': 'resource',
        'id': 'id'
    }

    def __init__(self, ref_link=None, name=None, display_name=None, organization_link=None, visible=None, org_id=None, expires_at=None, resource=None, id=None):  # noqa: E501
        """RoleResponse - a model defined in Swagger"""  # noqa: E501
        self._ref_link = None
        self._name = None
        self._display_name = None
        self._organization_link = None
        self._visible = None
        self._org_id = None
        self._expires_at = None
        self._resource = None
        self._id = None
        self.discriminator = None
        if ref_link is not None:
            self.ref_link = ref_link
        if name is not None:
            self.name = name
        if display_name is not None:
            self.display_name = display_name
        if organization_link is not None:
            self.organization_link = organization_link
        if visible is not None:
            self.visible = visible
        if org_id is not None:
            self.org_id = org_id
        if expires_at is not None:
            self.expires_at = expires_at
        if resource is not None:
            self.resource = resource
        if id is not None:
            self.id = id

    @property
    def ref_link(self):
        """Gets the ref_link of this RoleResponse.  # noqa: E501


        :return: The ref_link of this RoleResponse.  # noqa: E501
        :rtype: str
        """
        return self._ref_link

    @ref_link.setter
    def ref_link(self, ref_link):
        """Sets the ref_link of this RoleResponse.


        :param ref_link: The ref_link of this RoleResponse.  # noqa: E501
        :type: str
        """

        self._ref_link = ref_link

    @property
    def name(self):
        """Gets the name of this RoleResponse.  # noqa: E501


        :return: The name of this RoleResponse.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this RoleResponse.


        :param name: The name of this RoleResponse.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def display_name(self):
        """Gets the display_name of this RoleResponse.  # noqa: E501


        :return: The display_name of this RoleResponse.  # noqa: E501
        :rtype: str
        """
        return self._display_name

    @display_name.setter
    def display_name(self, display_name):
        """Sets the display_name of this RoleResponse.


        :param display_name: The display_name of this RoleResponse.  # noqa: E501
        :type: str
        """

        self._display_name = display_name

    @property
    def organization_link(self):
        """Gets the organization_link of this RoleResponse.  # noqa: E501


        :return: The organization_link of this RoleResponse.  # noqa: E501
        :rtype: str
        """
        return self._organization_link

    @organization_link.setter
    def organization_link(self, organization_link):
        """Sets the organization_link of this RoleResponse.


        :param organization_link: The organization_link of this RoleResponse.  # noqa: E501
        :type: str
        """

        self._organization_link = organization_link

    @property
    def visible(self):
        """Gets the visible of this RoleResponse.  # noqa: E501


        :return: The visible of this RoleResponse.  # noqa: E501
        :rtype: bool
        """
        return self._visible

    @visible.setter
    def visible(self, visible):
        """Sets the visible of this RoleResponse.


        :param visible: The visible of this RoleResponse.  # noqa: E501
        :type: bool
        """

        self._visible = visible

    @property
    def org_id(self):
        """Gets the org_id of this RoleResponse.  # noqa: E501


        :return: The org_id of this RoleResponse.  # noqa: E501
        :rtype: str
        """
        return self._org_id

    @org_id.setter
    def org_id(self, org_id):
        """Sets the org_id of this RoleResponse.


        :param org_id: The org_id of this RoleResponse.  # noqa: E501
        :type: str
        """

        self._org_id = org_id

    @property
    def expires_at(self):
        """Gets the expires_at of this RoleResponse.  # noqa: E501


        :return: The expires_at of this RoleResponse.  # noqa: E501
        :rtype: int
        """
        return self._expires_at

    @expires_at.setter
    def expires_at(self, expires_at):
        """Sets the expires_at of this RoleResponse.


        :param expires_at: The expires_at of this RoleResponse.  # noqa: E501
        :type: int
        """

        self._expires_at = expires_at

    @property
    def resource(self):
        """Gets the resource of this RoleResponse.  # noqa: E501


        :return: The resource of this RoleResponse.  # noqa: E501
        :rtype: str
        """
        return self._resource

    @resource.setter
    def resource(self, resource):
        """Sets the resource of this RoleResponse.


        :param resource: The resource of this RoleResponse.  # noqa: E501
        :type: str
        """

        self._resource = resource

    @property
    def id(self):
        """Gets the id of this RoleResponse.  # noqa: E501


        :return: The id of this RoleResponse.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this RoleResponse.


        :param id: The id of this RoleResponse.  # noqa: E501
        :type: str
        """

        self._id = id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(RoleResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RoleResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
